Index: code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj
===================================================================
--- code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj	(revision 2122)
+++ code/branches/physics/visual_studio/vc8/bullet_dynamics.vcproj	(revision 2149)
@@ -132,68 +132,80 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
 			>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btConeTwistConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btContactConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btContinuousDynamicsWorld.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btDiscreteDynamicsWorld.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btGeneric6DofConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btHingeConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btPoint2PointConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btRaycastVehicle.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btRigidBody.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSequentialImpulseConstraintSolver.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btSimpleDynamicsWorld.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSliderConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSolve2LinearConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btTypedConstraint.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btWheelInfo.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\Bullet-C-API.cpp"
-				>
-			</File>
+			<Filter
+				Name="ConstraintSolver"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btConeTwistConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btContactConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btGeneric6DofConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btHingeConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btPoint2PointConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSequentialImpulseConstraintSolver.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSliderConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSolve2LinearConstraint.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btTypedConstraint.cpp"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Dynamics"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btContinuousDynamicsWorld.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btDiscreteDynamicsWorld.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btRigidBody.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btSimpleDynamicsWorld.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\Bullet-C-API.cpp"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Vehicle"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btRaycastVehicle.cpp"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btWheelInfo.cpp"
+					>
+				</File>
+			</Filter>
 		</Filter>
 		<Filter
@@ -202,4 +214,104 @@
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
 			>
+			<Filter
+				Name="ConstraintSolver"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btConeTwistConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btConstraintSolver.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btContactConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btContactSolverInfo.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btGeneric6DofConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btHingeConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btJacobianEntry.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btPoint2PointConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSequentialImpulseConstraintSolver.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSliderConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSolve2LinearConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSolverBody.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btSolverConstraint.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\ConstraintSolver\btTypedConstraint.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Dynamics"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btContinuousDynamicsWorld.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btDiscreteDynamicsWorld.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btDynamicsWorld.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btRigidBody.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Dynamics\btSimpleDynamicsWorld.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="Vehicle"
+				>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btRaycastVehicle.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btVehicleRaycaster.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\bullet\BulletDynamics\Vehicle\btWheelInfo.h"
+					>
+				</File>
+			</Filter>
 		</Filter>
 	</Files>