Index: code/branches/physics/src/orxonox/objects/HelloBullet.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/HelloBullet.cc	(revision 2149)
+++ code/branches/physics/src/orxonox/objects/HelloBullet.cc	(revision 2150)
@@ -57,16 +57,17 @@
 
 
-        btVector3 worldAabbMin(-10000,-10000,-10000);
-        btVector3 worldAabbMax(10000,10000,10000);
-        btAxisSweep3* broadphase = new btAxisSweep3(worldAabbMin,worldAabbMax,maxProxies);
+  //      btVector3 worldAabbMin(-10000,-10000,-10000);
+  //      btVector3 worldAabbMax(10000,10000,10000);
+  //      btAxisSweep3* broadphase = new btAxisSweep3(worldAabbMin,worldAabbMax,maxProxies);
 
-        btDefaultCollisionConfiguration* collisionConfiguration = new btDefaultCollisionConfiguration();
-        btCollisionDispatcher* dispatcher = new btCollisionDispatcher(collisionConfiguration);
+  //      btDefaultCollisionConfiguration* collisionConfiguration = new btDefaultCollisionConfiguration();
+  //      btCollisionDispatcher* dispatcher = new btCollisionDispatcher(collisionConfiguration);
 
-        btSequentialImpulseConstraintSolver* solver = new btSequentialImpulseConstraintSolver;
+  //      btSequentialImpulseConstraintSolver* solver = new btSequentialImpulseConstraintSolver;
 
-        dynamicsWorld = new btDiscreteDynamicsWorld(dispatcher,broadphase,solver,collisionConfiguration);
+  //      dynamicsWorld = new btDiscreteDynamicsWorld(dispatcher,broadphase,solver,collisionConfiguration);
 
-        dynamicsWorld->setGravity(btVector3(0,-10,0));
+	dynamicsWorld =  creator->getScene()->getPhysicalWorld();
+        dynamicsWorld-> setGravity(btVector3(0,-10,0));
 
 
@@ -180,8 +181,8 @@
     void HelloBullet::tick(float dt)
     {
-                dynamicsWorld->stepSimulation(1/60.f,10);
+                dynamicsWorld->stepSimulation(dt,10);
                 btTransform trans;
                 fallRigidBody->getMotionState()->getWorldTransform(trans);
-	        COUT(0) << "sphere height: " << trans.getOrigin().getY() << std::endl;
+	       // COUT(0) << "sphere height: " << trans.getOrigin().getY() << std::endl;
 		sceneNode_ -> setPosition(Vector3(0,trans.getOrigin().getY(),0));
 	//	msleep(20);
Index: code/branches/physics/src/orxonox/objects/Scene.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/Scene.cc	(revision 2149)
+++ code/branches/physics/src/orxonox/objects/Scene.cc	(revision 2150)
@@ -62,4 +62,21 @@
                 this->rootSceneNode_ = 0;
             }
+	// create bullet world; bullet solver etc.
+
+        // int maxProxies = 1024;
+
+        btVector3 worldAabbMin(-10000,-10000,-10000);
+        btVector3 worldAabbMax(10000,10000,10000);
+        bt32BitAxisSweep3* broadphase = new bt32BitAxisSweep3(worldAabbMin,worldAabbMax);
+
+	this -> collisionConfiguration_ = new btDefaultCollisionConfiguration();
+        this -> dispatcher_ = new btCollisionDispatcher(collisionConfiguration_);
+
+        this -> solver_ = new btSequentialImpulseConstraintSolver;
+
+        this -> dynamicsWorld_ =  new btDiscreteDynamicsWorld(dispatcher_,broadphase,solver_,collisionConfiguration_);
+
+      //  dynamicsWorld->setGravity(btVector3(0,-10,0));
+
         }
         else
Index: code/branches/physics/src/orxonox/objects/Scene.h
===================================================================
--- code/branches/physics/src/orxonox/objects/Scene.h	(revision 2149)
+++ code/branches/physics/src/orxonox/objects/Scene.h	(revision 2150)
@@ -36,4 +36,6 @@
 #include "util/Math.h"
 
+#include "ogrebullet/Dynamics/OgreBulletDynamics.h"
+
 namespace orxonox
 {
@@ -51,4 +53,7 @@
             inline Ogre::SceneNode* getRootSceneNode() const
                 { return this->rootSceneNode_; }
+
+            inline btDiscreteDynamicsWorld* getPhysicalWorld() const
+                { return this->dynamicsWorld_; }
 
             void setSkybox(const std::string& skybox);
@@ -75,4 +80,11 @@
             Ogre::SceneManager*    sceneManager_;
             Ogre::SceneNode*       rootSceneNode_;
+
+	    btDiscreteDynamicsWorld* dynamicsWorld_;
+	    btSequentialImpulseConstraintSolver* solver_;
+	    btDefaultCollisionConfiguration* collisionConfiguration_;
+	    btCollisionDispatcher* dispatcher_; 
+	    // Point auf Bullet btDynamics world && solver
+
             std::string            skybox_;
             ColourValue            ambientLight_;